#ifdef GL_ES																
	precision mediump float;												
	varying lowp vec4 v_fragmentColor;										
	varying mediump vec2 v_texCoord;										
#else																		
	varying vec4 v_fragmentColor;											
	varying vec2 v_texCoord;												
#endif																		
uniform vec2 u_resolution;													
uniform float u_rotate;														
uniform float u_shadow_size;												
vec4 composite(vec4 over, vec4 under) 										
{ 																			
	return over + (1.0 - over.a)*under; 									
}  																			
void main(){  																
	vec2 shadowOffset = vec2(u_shadow_size/u_resolution.x * cos(u_rotate), u_shadow_size/u_resolution.y * sin(u_rotate));  			
	vec4 textureColor = texture2D(CC_Texture0, v_texCoord);					
	float shadowMask = texture2D(CC_Texture0, v_texCoord - shadowOffset ).a;
	const float shadowOpacity = 0.3;  										
	vec4 shadowColor = vec4(0,0,0,shadowMask *shadowOpacity);  				
	gl_FragColor = composite(textureColor, shadowColor);  					
}