#ifdef GL_ES
precision mediump float;
#endif
uniform float u_resolution;
uniform float u_radius;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

const float f1 = 0.001;
const float f2 = 0.002;
const float f3 = 0.012;
const float f4 = 0.020;
const float f5 = 0.068;
const float f6 = 0.109;
const float fc = 0.172;

void main() {
	vec4 sum = vec4(0.0);
	vec2 tc = v_texCoord;
	float blur = u_radius/u_resolution/3.0; 
	
	sum += texture2D(CC_Texture0, vec2(tc.x, tc.y)) * fc;

	sum += texture2D(CC_Texture0, vec2(tc.x - 1.0 * blur, tc.y)) * f6;
	sum += texture2D(CC_Texture0, vec2(tc.x + 1.0 * blur, tc.y)) * f6;
	sum += texture2D(CC_Texture0, vec2(tc.x, tc.y - 1.0 * blur)) * f6;
	sum += texture2D(CC_Texture0, vec2(tc.x, tc.y + 1.0 * blur)) * f6;

	sum += texture2D(CC_Texture0, vec2(tc.x - 1.0 * blur, tc.y - 1.0 * blur)) * f5;
	sum += texture2D(CC_Texture0, vec2(tc.x - 1.0 * blur, tc.y + 1.0 * blur)) * f5;
	sum += texture2D(CC_Texture0, vec2(tc.x + 1.0 * blur, tc.y - 1.0 * blur)) * f5;
	sum += texture2D(CC_Texture0, vec2(tc.x + 1.0 * blur, tc.y + 1.0 * blur)) * f5;

	sum += texture2D(CC_Texture0, vec2(tc.x - 2.0 * blur, tc.y)) * f4;
	sum += texture2D(CC_Texture0, vec2(tc.x + 2.0 * blur, tc.y)) * f4;
	sum += texture2D(CC_Texture0, vec2(tc.x, tc.y - 2.0 * blur)) * f4;
	sum += texture2D(CC_Texture0, vec2(tc.x, tc.y + 2.0 * blur)) * f4;

	sum += texture2D(CC_Texture0, vec2(tc.x - 2.0 * blur, tc.y - 1.0 * blur)) * f3;
	sum += texture2D(CC_Texture0, vec2(tc.x - 2.0 * blur, tc.y + 1.0 * blur)) * f3;
	sum += texture2D(CC_Texture0, vec2(tc.x + 1.0 * blur, tc.y - 2.0 * blur)) * f3;
	sum += texture2D(CC_Texture0, vec2(tc.x + 1.0 * blur, tc.y + 2.0 * blur)) * f3;
	sum += texture2D(CC_Texture0, vec2(tc.x - 1.0 * blur, tc.y - 2.0 * blur)) * f3;
	sum += texture2D(CC_Texture0, vec2(tc.x - 1.0 * blur, tc.y + 2.0 * blur)) * f3;
	sum += texture2D(CC_Texture0, vec2(tc.x + 2.0 * blur, tc.y - 1.0 * blur)) * f3;
	sum += texture2D(CC_Texture0, vec2(tc.x + 2.0 * blur, tc.y + 1.0 * blur)) * f3;

	sum += texture2D(CC_Texture0, vec2(tc.x - 3.0 * blur, tc.y)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x + 3.0 * blur, tc.y)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x, tc.y - 3.0 * blur)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x, tc.y + 3.0 * blur)) * f1;

	sum += texture2D(CC_Texture0, vec2(tc.x - 3.0 * blur, tc.y - 1.0 * blur)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x - 3.0 * blur, tc.y + 1.0 * blur)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x + 1.0 * blur, tc.y - 3.0 * blur)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x + 1.0 * blur, tc.y + 3.0 * blur)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x - 1.0 * blur, tc.y - 3.0 * blur)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x - 1.0 * blur, tc.y + 3.0 * blur)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x + 3.0 * blur, tc.y - 1.0 * blur)) * f1;
	sum += texture2D(CC_Texture0, vec2(tc.x + 3.0 * blur, tc.y + 1.0 * blur)) * f1;

	gl_FragColor = v_fragmentColor * sum;
}